#
# spec file for package xrdp
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define _fwdefdir %{_sysconfdir}/sysconfig/SuSEfirewall2.d/services
Name:           xrdp
Version:        0.9.0~git.1456906198.f422461
Release:        7.1
Summary:        Open Source remote desktop protocol (RDP) server
License:        Apache-2.0 and GPL-2.0+
Group:          System/X11/Utilities
Url:            https://github.com/neutrinolabs/xrdp
Source0:        xrdp-%{version}.tar.gz
Source1:        xrdp.fw
Source2:        sysconfig.xrdp
Source3:        force_stop
Source4:        openSUSE.bmp
Source100:      %{name}-rpmlintrc
# PATCH-FIX-OPENSUSE xrdp-pam.patch bnc#441750 - hfiguiere@novell.com
Patch1:         xrdp-pam.patch
# PATCH-FIX-UPSTREAM xrdp-fix-buildtime-warnings.patch - fezhang@suse.com -- fix warnings in build time, backported from upstream devel branch
Patch2:         xrdp-fix-buildtime-warnings.patch
# PATCH-FIX-OPENSUSE xrdp-default-config.patch - cyberorg@opensuse.org -- Adjust default settings to openSUSE standards
Patch3:         xrdp-default-config.patch
# PATCH-FIX-OPENSUSE xrdp-disable-8-bpp-vnc-support.patch bsc#991059 - fezhang@suse.com -- disable 8 bpp support for vnc connections
Patch4:         xrdp-disable-8-bpp-vnc-support.patch
# PATCH-FIX-UPSTREAM xrdp-Allow-sessions-with-32-bpp.patch.patch bsc#1022098 - vliaskovitis@suse.com -- Allow sessions with 32 bpp
Patch5:         xrdp-Allow-sessions-with-32-bpp.patch.patch
# PATCH-FIX-UPSTREAM xrdp-vnc-enable-32-bpp-support-for-Xvnc-it-actually-works.patch bsc#1022098 - vliaskovitis@suse.com -- vnc: enable 32 bpp support for Xvnc, it actually works
Patch6:         xrdp-vnc-enable-32-bpp-support-for-Xvnc-it-actually-works.patch
# PATCH-FIX-UPSTREAM xrdp-Fix-support-for-32-bpp-clients-connecting-to-16-bpp-.patch bsc#1022098 - vliaskovitis@suse.com -- Fix support for 32-bpp clients connecting to 16-bpp VNC
Patch7:         xrdp-Fix-support-for-32-bpp-clients-connecting-to-16-bpp-.patch
# PATCH-FIX-UPSTREAM xrdp-dont-set-LANG.patch bsc#1023988 - fezhang@suse.com -- sesman should not set LANG
Patch8:         xrdp-dont-set-LANG.patch
# PATCH-FEATURE-SLE xrdp-avahi.diff bnc#586785 - hfiguiere@novell.com -- Add Avahi support
Patch11:        xrdp-avahi.diff
# PATCH-FIX-SLE xrdp-filter-tab-from-mstsc-on-focus-change.patch bnc#601996 bnc#623534 - dliang@novell.com -- filter the fake tab key which is used to notify the session
Patch12:        xrdp-filter-tab-from-mstsc-on-focus-change.patch
# PATCH-FIX-SLE xrdp-bsc965647-allow-admin-choose-desktop.patch bsc#965647 - fezhang@suse.com -- Allow administrator choose the desktop displayed
Patch13:        xrdp-bsc965647-allow-admin-choose-desktop.patch
# PATCH-FEATURE-SLE xrdp-fate318398-change-expired-password.patch fate#318398 - fezhang@suse.com -- enable user to update expired password via PAM
Patch14:        xrdp-fate318398-change-expired-password.patch
# PATCH-FEATURE-SLE xrdp-fate319683-allow-vnc-resizing.patch fate#319683 bsc#948062 - fezhang@suse.com -- allow resizing in VNC sessions
Patch15:        xrdp-fate319683-allow-vnc-resizing.patch
# PATCH-FIX-OPENSUSE xrdp-openSUSE-logo.patch - fezhang@suse.com -- use openSUSE logo in login dialog
Patch21:        xrdp-openSUSE-logo.patch
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  fdupes
BuildRequires:  libX11-devel
BuildRequires:  libXfixes-devel
BuildRequires:  libXrandr-devel
BuildRequires:  libavahi-devel
BuildRequires:  libtool
BuildRequires:  openssl-devel
BuildRequires:  pam-devel
BuildRequires:  pkg-config
BuildRequires:  pkgconfig(systemd)
Requires:       xorg-x11-Xvnc
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
A full functionnal Linux terminal server, capable of accepting
connection from rdesktop and Microsoft's own terminal server / remote
desktop clients.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%if ! 0%{?is_opensuse}
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%else
%patch21 -p1
%endif

%build
sh ./bootstrap
%configure \
   --with-systemdsystemunitdir=%{_unitdir}
make %{?_smp_mflags}

%install
make %{?_smp_mflags} DESTDIR=%{buildroot} install
find %{buildroot} -name '*.a' -exec rm {} \;
find %{buildroot} -type f -name "*.la" -delete -print
mkdir -p %{buildroot}/%{_fwdefdir}
install -m 644 %{SOURCE1} %{buildroot}/%{_fwdefdir}/xrdp
mkdir -p %{buildroot}/%{_localstatedir}/adm/fillup-templates
install -m 644 %{SOURCE2} %{buildroot}/%{_localstatedir}/adm/fillup-templates/sysconfig.xrdp
mkdir -p %{buildroot}/%{_prefix}/lib/initscripts/legacy-actions/xrdp
install -m 755 %{SOURCE3} %{buildroot}/%{_prefix}/lib/initscripts/legacy-actions/xrdp/force_stop
%if 0%{?is_opensuse}
install %{SOURCE4} %{buildroot}%{_datadir}/%{name}/
%endif

ln -sf %{_sbindir}/service %{buildroot}%{_sbindir}/rcxrdp
ln -sf %{_sbindir}/service %{buildroot}%{_sbindir}/rcxrdp-sesman

# remove init script that conflicts with systemd service
rm -rf %{buildroot}/%{_initddir}

%fdupes -s %{buildroot}

%pre
%service_add_pre xrdp-sesman.service
%service_add_pre xrdp.service

%post
/sbin/ldconfig
%service_add_post xrdp-sesman.service
%service_add_post xrdp.service
%{fillup_only -n xrdp}
if [ ! -e %{_sysconfdir}/xrdp/rsakeys.ini ]; then
    xrdp-keygen xrdp %{_sysconfdir}/xrdp/rsakeys.ini
    if [ $? -ne 0 ] || [ ! -e %{_sysconfdir}/xrdp/rsakeys.ini ]; then
        echo "Could not generate rsakeys.ini, please check manually!"
    fi
fi
exit 0

%preun
%stop_on_removal
%service_del_preun xrdp.service
%service_del_preun xrdp-sesman.service

%postun
/sbin/ldconfig
%service_del_postun xrdp.service
%service_del_postun xrdp-sesman.service
%restart_on_update

%files
%defattr(-,root,root)

%dir %{_datadir}/xrdp
%dir %{_libdir}/xrdp
%dir %{_sysconfdir}/xrdp
%dir %{_sysconfdir}/xrdp/pulse
%config %{_fwdefdir}/xrdp
%config(noreplace) %{_sysconfdir}/default/xrdp
%config(noreplace) %{_sysconfdir}/pam.d/xrdp-sesman
%config(noreplace) %{_sysconfdir}/xrdp/sesman.ini
%config(noreplace) %{_sysconfdir}/xrdp/xrdp.ini
%doc COPYING *.txt
%{_bindir}/xrdp*
%{_datadir}/xrdp/*
%{_libdir}/xrdp/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man8/*
%{_prefix}/lib/initscripts/legacy-actions/xrdp
%{_sbindir}/rc*
%{_sbindir}/xrdp*
%{_sysconfdir}/xrdp/km*.ini
%{_sysconfdir}/xrdp/pulse/default.pa
%{_sysconfdir}/xrdp/xrdp_keyboard.ini
%{_unitdir}/xrdp*

%ghost %{_localstatedir}/log/xrdp-sesman.log

%config(noreplace) %{_sysconfdir}/xrdp/
%ghost %config(noreplace) %{_sysconfdir}/xrdp/rsakeys.ini
%config %{_localstatedir}/adm/fillup-templates/sysconfig.xrdp

%changelog
* Thu May 25 2017 fezhang@suse.com
- Add xrdp-dont-set-LANG.patch: Backport upstream commit 5575197,
  sesman should stop setting LANG and let initialization scripts
  take care of it (bsc#1023988).
* Thu May 11 2017 fezhang@suse.com
- Update xrdp-fate319683-allow-vnc-resizing.patch:
  + Fix a crash caused by double freeing stream (bsc#1034606).
  + Remove DisplaySize from Xvnc default policy to enable it
    resizing.
* Mon Feb  6 2017 fezhang@suse.com
- Add xrdp-fate319683-allow-vnc-resizing.patch:
  Add support for ExtendedDesktopSize VNC extension into xrdp's VNC
  client to allow it to do resizing, so that returning clients can
  reconnect to session if their resolutions changed (FATE#319683,
  bsc#948062).
* Wed Feb  1 2017 vliaskovitis@suse.com
- Backport upstream patches for 32bpp support (bsc#1022098)
  - Add xrdp-Allow-sessions-with-32-bpp.patch.patch
  - Add xrdp-vnc-enable-32-bpp-support-for-Xvnc-it-actually-works.patch
  - Add xrdp-Fix-support-for-32-bpp-clients-connecting-to-16-bpp-.patch
* Tue Aug 30 2016 fezhang@suse.com
- Add xrdp-disable-8-bpp-vnc-support.patch:
  Disable 8 bpp vnc support. Xvnc drops support for 8 bpp since
  1.4.0. Trying to launch Xvnc in 8 bpp will cause it to dump core
  (bsc#991059).
* Mon Aug  1 2016 fezhang@suse.com
- Add obs source services:
  + tar_scm
  + recompress
  + set_version
- Update to version 0.9.0~git.1456906198.f422461:
  Fix tarball naming from 0.9.0git to 0.9.0~git to conform openSUSE
  naming scheme for pre-release version.
  + Numlock out of sync fix
  + neutrinordp: minor changes, coding style, log level
  + Update faq-compile.txt
  + Change to allow authentication against all authentication
    methods.
  + Add details for crypt_level=fips to man page
  + libxrdp: no logic change, tabs to spaces
  + libxrdp: opps, fix typeo
  + Fix "\ _" on jp keyboard
  + xrdp_keyboard.ini: Fix jp keyboard model
  + update xorgxrdp
  + add keyboard options to xrdp_client_info
  + xorgxrdp=68412e5
- Add an extra legacy service action force_stop:
  Forcefully killing xrdp processes when it cannot be stopped
  normally.
  Usage:
    $ service xrdp force_stop
    or
    $ rcxrdp force_stop
- Merge X11:RemoteDesktop and SLE package, unfortunately we have to
  drop the original X11:RemoteDesktop xrdp changelog due to
  unresolvable chronological inconsistences with the SLE changelog.
  + Add xrdp-default-config.patch:
    Rebased from contribution of cyberorg@opensuse.org in original
    X11:RemoteDesktop package. Adjust various default settings to
    openSUSE standards including removing dysfunctional backend
    entries from xrdp login UI (bsc#989309).
  + Add xrdp-openSUSE-logo.patch:
    Split from xrdp-default-config.patch. Add openSUSE logo to xrdp
    login UI.
    Add openSUSE.bmp:
    Taken from the original X11:RemoteDesktop package, the logo.
  + Add xrdp-fix-buildtime-warnings.patch:
    Fix buid time warnings, backported from commit ded462a.
  + Drop xrdp-lsb.patch:
    SysV and LSB init scripts are no longer supported by systemd
    (bnc#442211).
  + Update xrdp-avahi.diff (bnc#586785).
  + Update xrdp-pam.patch (bnc#441750).
  + Update xrdp-bsc965647-allow-admin-choose-desktop.patch
    (bsc#984834).
  + Upbate xrdp-fate318398-change-expired-password.patch
    (FATE#318398).
  + Cleanup specfile.
* Wed Jun 15 2016 fezhang@suse.com
- Update xrdp-bsc965647-allow-admin-choose-desktop.patch:
  Fix startwm.sh broken by changed gnome-session environments
  (bsc#965647, bsc#984834).
* Wed Jun  1 2016 fezhang@suse.com
- Update xrdp-fate318398-change-expired-password.patch:
  Fixed some internal bugs (FATE#318398).
* Mon May 30 2016 fezhang@suse.com
- Add xrdp-fate318398-change-expired-password.patch:
  Enable the user to update expired password in login window
  (FATE#318398).
* Fri Apr 22 2016 fezhang@suse.com
- Update to version 0.9.0, git master branch id f422461
  (FATE#319910).
  + Added FIPS support.
  - Drop xrdp-change-default-crypto_level.patch:
    fixed upstream (bnc#764044).
  - Drop xrdp-some-minor-changes-to-arch.h.patch:
    fixed upstream (bnc#910824).
  - Drop xrdp-fix-segfaults-in-xrdp-chansrv-code.patch:
    fixed upstream (bnc#899105).
  - Drop xrdp-add-systemd-support.patch:
    fixed upstream (bnc#899105).
  - Drop xrdp-tab-from-mstsc-updated.patch:
    merged into xrdp-filter-tab-from-mstsc-on-focus-change.patch,
    which introduced the bug fixed by this patch (bnc#623534).
  - Rebase xrdp-avahi.diff (bnc#586785).
  - Rebase xrdp-pam.patch (bnc#441750).
  - Rebase xrdp-bsc965647-allow-admin-choose-desktop.patch
    (bsc#965647).
  - Rebase xrdp-lsb.patch (bnc#442211).
  - Rebase xrdp-filter-tab-from-mstsc-on-focus-change.patch
    (bnc#601996, bnc#623534).
* Wed Apr 13 2016 fezhang@suse.com
- fix rsakeys generation test (bsc#973130) in xrdp.spec.
* Wed Mar  2 2016 fezhang@suse.com
- allow admin choose desktop (bsc#965647)
  add xrdp-bsc965647-allow-admin-choose-desktop.patch
* Tue Dec 23 2014 rmilasan@suse.com
- Fix endian issues (bnc#910824).
  xrdp-some-minor-changes-to-arch.h.patch.
* Fri Nov 21 2014 rmilasan@suse.de
- add systemd support into xrdp (bnc#899105).
- fix some segfaults in xrdp-chansrv (bnc#899105).
* Fri Apr 25 2014 fezhang@suse.com
- update source to version 0.6.1.
- rebase the following patches (bnc#871761)
  - xrdp-avahi.diff (bnc#586785)
  - xrdp-lsb.patch (bnc#442211)
  - xrdp-pam.patch (bnc#441750)
  - xrdp-filter-tab-from-mstsc-on-focus-change.patch (bnc#601996)
  - xrdp-tab-from-mstsc-updated.patch (bnc#623534)
  - xrdp-change-default-crypto_level.patch (bnc#764044)
- drop the following patches (bnc#871761)
  - xrdp-0.4.1..48f00f.diff.bz2
  - xrdp-NOMAD.diff
  - xrdp-558195-display-id.patch
  - xrdp-xdmx-backend-cfg.patch
  - xrdp-auth-fix.patch
  - xrdp-clean-auth-file.patch
  - bug-569797_xrdp-sesman-ini-add-dmx-args.diff
  - xrdp-available-display.patch
  - xrdp-xdmx-setxkbmap-params.patch
  - xrdp-xkb.patch
  - xrdp-807610-24-bpp.patch
  - xrdp-810265-port-not-available.patch
* Sat May  4 2013 dliang@suse.com
- add xrdp-810265-port-not-available.patch to fix bnc#810265
* Mon Mar 25 2013 dliang@suse.com
- xrdp-807610-24-bpp.patch add 24 bpp support (bnc#807610)
* Thu Jun  7 2012 lzwang@suse.com
- set default crypt level to high. (bnc#764044)
* Mon Jan  9 2012 sreeves@suse.com
- Update xrdp-NOMAD.diff to fix remaining issues in bnc#442182.
* Thu Nov  3 2011 lzwang@suse.com
- Add xkb support.(bnc#497578)
* Tue Oct 12 2010 lzwang@novell.com
- Add xrdp-xdmx-setxkbmap-params.patch to fix bnc#597298.
* Mon Sep 20 2010 dliang@novell.com
- Update xrdp-clean-auth-file.patch as  Marcus Meissner's advice
- Update  xrdp-available-display.patch to fix bnc#616761
    bnc#616744
- Add xrdp-tab-from-mstsc-updated.patch to fix bnc#623534
* Thu Aug 12 2010 ro@suse.de
- fix broken patch xrdp-avahi.diff including a duplicate
  hunk from xrdp-NOMAD.diff
* Tue Jun 29 2010 dliang@novell.com
- xrdp-xdmx-backend-cfg.patch   bnc#505015
  - add backend option to use different 'depth'
  xrdp-filter-tab-from-mstsc-on-focus-change.patch bnc#601996
  - filter the fake tab key which is used to notify the session
  xrdp-auth-fix.patch bnc#503677
  - login even if the first attemp was done by root.
  xrdp-clean-auth-file.patch  bnc#505015
  - clean the auth file when a session was end
  bug-569797_xrdp-sesman-ini-add-dmx-args.diff bnc#569797
  - disable the compose effect by default.
    done by Lance Wang (lzwang@novell.com)
  xrdp-available-display.patch : updated patch of bnc#558195
* Thu Apr  1 2010 dliang@novell.com
- Update xrdp-avahi.diff and xrdp-NOMAD.diff (bnc#586785)
* Thu Mar  4 2010 dliang@novell.com
- Get the valid unused display id. (bnc#558195)
* Wed Mar 18 2009 davidr@novell.com
- Send complete login info requests to sesman. (bnc#486632)
* Tue Mar 17 2009 davidr@novell.com
- Use correct X11 rdp port number when display number is
  greater than 99. (bnc#484086)
* Wed Feb 25 2009 davidr@novell.com
- Allow up to 128 simultaneous sessions. (bnc#477376)
* Wed Feb 11 2009 davidr@novell.com
- Fix a number of vulnerabilities. (bnc#442182) (bnc#466373)
- Don't reset username/password. (bnc#442293)
- Fix xrdp-sesrun. (bnc#466373)
- Fix user name selection support. (bnc#474840)
* Thu Feb  5 2009 davidr@novell.com
- Add proper Xdmx keyboard layout handling and allow X server to
  reset when last client disconnects. (bnc#447682) (bnc#442292)
* Thu Jan 22 2009 davidr@novell.com
- Fall-back to regular RDP connection when X11 channel
  fails. (bnc#450142)
- Make sure multiple RDP connections to the same DMX
  session can exist at the same.
* Fri Jan  9 2009 davidr@novell.com
- Fix multiple buffer overflows. (bnc#450898)
* Tue Jan  6 2009 davidr@novell.com
- Properly install firewall definition file. (bnc#460835)
* Mon Jan  5 2009 davidr@novell.com
- Register session as remote. (bnc#441751)
* Tue Dec 23 2008 hfiguiere@suse.de
- Fixed xrdp-pam.patch according the the last comment in bnc#441750
* Tue Dec 23 2008 davidr@novell.com
- Add firewall definition (bnc#460835)
  source: xrdp.fw
* Tue Dec  9 2008 hfiguiere@suse.de
- Added patch xrdp-pam.patch: fix pam config file, and fix pam
  calls to use the proper service name (bnc#441750)
* Sun Nov 23 2008 davidr@novell.com
- Use authorization files for all sessions. (bnc#442223)
- Use authorization file for X11rdp. (bnc#442223)
* Tue Nov 18 2008 davidr@novell.com
- Fix initial screen resolution.
* Wed Nov 12 2008 davidr@novell.com
- Fix X server startup issue.
  * Avoid using unix domain socket files to determine the
    presence of X servers.
* Fri Nov  7 2008 hfiguiere@suse.de
- Remove fuzz from xrdp-avahi.diff
- Add xrdp-lsb.patch
  * Make the init script LSB compliant (bnc#442211)
* Fri Nov  7 2008 hfiguiere@suse.de
- Add /usr/sbin/rcxrdp (bnc#442692)
* Thu Nov  6 2008 ro@suse.de
- fix last change (just adding "#" does not work for multiline rpm
  macros).
* Wed Nov  5 2008 hfiguiere@suse.de
- Don't enable xrdp by default (bnc#441742)
* Mon Oct 27 2008 davidr@novell.com
- Include .so files for modules.
* Mon Oct 27 2008 davidr@novell.com
- Update xrdp-NOMAD.diff
  * Fix zlib compression.
* Sun Oct 12 2008 hfiguiere@suse.de
- Update xrdp-NOMAD.diff
  * Fix openSUSE branding
* Wed Oct  8 2008 hfiguiere@suse.de
- Update xrdp-avahi.diff
  * remove warnings for missing prototypes.
* Wed Sep 17 2008 hfiguiere@suse.de
- Update xrdp-NOMAD.diff
  * Fix Xdmx command line arguments
  * Fix session data matching for XDMX sessions
* Thu Sep 11 2008 hfiguiere@suse.de
- Add Avahi support.
- More comprehensive support of NOMAD.
* Tue Sep  2 2008 hfiguiere@suse.de
- Initial release.
